import { Action } from '@ngrx/store';
import { DegreePlan } from '@app/core/models/degree-plan';
import { PlannedTerm } from '@app/core/models/planned-term';
import { Term } from '@app/core/models/term';

export enum PlanActionTypes {
	InitialPlanLoadResponse = '[Plan] Initial Load Response',
	ChangeVisiblePlanRequest = '[Plan] Change Visible Request',
	ChangeVisiblePlanResponse = '[Plan] Change Visible Response'
}

export class InitialPlanLoadResponse implements Action {
	public readonly type = PlanActionTypes.InitialPlanLoadResponse;
	constructor(
		public payload: {
			visibleRoadmapId: number;
			visibleTerms: PlannedTerm[];
			allDegreePlans: DegreePlan[];
			activeTerms: Term[];
		}
	) {}
}

export class ChangeVisiblePlanRequest implements Action {
	public readonly type = PlanActionTypes.ChangeVisiblePlanRequest;
	constructor(public payload: { newVisibleRoadmapId: number }) {}
}

export class ChangeVisiblePlanResponse implements Action {
	public readonly type = PlanActionTypes.ChangeVisiblePlanResponse;
	constructor(
		public payload: { visibleRoadmapId: number; visibleTerms: PlannedTerm[] }
	) {}
}
